// [2013 07 16] DirectX 3D.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "[2013 07 16] DirectX 3D.h"


/*----------------------------------------------------------
	DirectX9HvO~O
		DirectX GraphicsTv

	DXGSample01.cpp
		u{IȃEChEEAvP[Vv

	(C) 2003 NARITA, Takuro
		E-Mail	narita@a1.mbn.or.jp
--------------------------------------------------------------*/

#define WIN32_LEAN_AND_MEAN	// wb_[炠܂gȂ֐Ȃ

#include <windows.h>
#include <tchar.h>
#include <d3dx9.h>
#include <dxerr9.h>

#include "resource.h"

#define RELEASE(x)	if(x){x->Release();x=NULL;}

/*-------------------------------------------
	O[oϐ(AvP[V֘A)
--------------------------------------------*/
HINSTANCE	g_hInstance		= NULL;	// CX^XEnh
HWND		g_hWindow		= NULL;	// EChEEnh
HMENU		g_hMenu			= NULL;	//	j[Enh

TCHAR		g_szAppTitle[]	= _T("DirectX 9.0 Graphics Sample01");
TCHAR		g_szWndClass[]	= _T("DX9GS01");

RECT		g_rectWindow;

// N̕`̈TCY
bool		g_bWindow = true;	//	true:EBhE[h false:tXN[[h

SIZE		g_sizeWindowMode	= { 640, 480 };		// EChEE[h
SIZE		g_sizeFullMode		= { 1024, 768 };	//	tXN[E[h
D3DFORMAT	g_formatFull		= D3DFMT_X8R8G8B8;	//	fBXvC(obNEobt@)EtH[}bg


// foCXݒ̊]l
D3DFORMAT	g_fmtDisplay[] = 						// ]fBXvCEtH[}bg
	{ D3DFMT_X8R8G8B8, D3DFMT_X1R5G5B5, D3DFMT_R5G6B5 };
D3DFORMAT	g_fmtRendTexter[] = 					// ]郌_OEeNX`̃tH[}bg
	{ D3DFMT_X8R8G8B8, D3DFMT_X1R5G5B5, D3DFMT_R5G6B5 };
D3DFORMAT	g_fmtDepthStencil = D3DFMT_D24S8;		// ][x/XeVobt@̃tH[}bg(D3DFMT_UNKNOWNŖgp)
D3DMULTISAMPLE_TYPE g_MultiSampleType[] =
		{ D3DMULTISAMPLE_4_SAMPLES, D3DMULTISAMPLE_NONMASKABLE };
													// ]}`ETvÕ^Cv
UINT		g_Interval    = D3DPRESENT_INTERVAL_IMMEDIATE;		// ]Present̎s[g


// AvP[V̓tO
bool		g_bActive		= false;	// ANeBu

/*-------------------------------------------
	O[oϐ(DirectX֘A)
--------------------------------------------*/

// C^[tFCX
LPDIRECT3D9				g_pD3D			= NULL; // Direct3DC^[tFCX
LPDIRECT3DDEVICE9		g_pD3DDevice	= NULL; // Direct3DDeviceC^[tFCX
D3DPRESENT_PARAMETERS	g_D3DPP;				// D3DDevice̐ݒ

D3DPRESENT_PARAMETERS	g_D3DPPWindow;			// D3DDevice̐ݒ(EChEE[hp)
D3DPRESENT_PARAMETERS	g_D3DPPFull;			// D3DDevice̐ݒ(tXN[E[hp)

D3DFORMAT				g_fmtRendTexterWindow;	// _OEeNX`̃tH[}bg(EChEp)
D3DFORMAT				g_fmtRendTexterFull;	// _OEeNX`̃tH[}bg(tXN[p)

bool g_bDeviceLost = false;						// foCX̏tO

// XvCg@\
LPD3DXSPRITE			g_pD3DXSprite = NULL;	// XvCg
LPDIRECT3DTEXTURE9		g_pD3DTexture = NULL;	// XvCgɎgeNX`
TCHAR g_szSpriteFile[] = _T("canvas.png");		// XvCgɎg摜t@C

// tHg@\
LPD3DXFONT				g_pD3DXFont = NULL;		// D3DXFontC^[tFCX

// }EXEJ[\@\
TCHAR g_szCursorFile[] = _T("Cursor.dds");		// J[\Ɏg摜t@C 

// ʃLv`@\
TCHAR g_szFontBufferFile[] = _T("save.bmp");	// Lv`ʂ̉摜t@C



LPD3DXMESH			g_pD3DXMesh = NULL;
DWORD				g_dwNumMaterials = 0L;
LPDIRECT3DTEXTURE9	*g_pMeshTexture = NULL;
D3DMATERIAL9		*g_pMeshMaterials = NULL;
/*-------------------------------------------
	֐`
--------------------------------------------*/

LRESULT CALLBACK MainWndProc(HWND hWnd,UINT msg,UINT wParam,LONG lParam);

/*-------------------------------------------
	AvP[ViŏɈxĂ΂j
--------------------------------------------*/
HRESULT InitApp(HINSTANCE hInst)
{
	// AvP[ṼCX^XEnhۑ
	g_hInstance = hInst;

	// IME֎~
//	ImmDisableIME(-1);

	// EChEENX̓o^
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= MainWndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= g_hInstance;
	wcex.hIcon			= LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_MY20130716DIRECTX3D));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_MY20130716DIRECTX3D);
	wcex.lpszClassName	= g_szWndClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	if (!RegisterClassEx(&wcex))
		return DXTRACE_ERR("InitApp", GetLastError());

	// CEEChE쐬(EChEE[hp)
	g_rectWindow.top	= 0;
	g_rectWindow.left	= 0;
	g_rectWindow.right	= g_sizeWindowMode.cx;
	g_rectWindow.bottom	= g_sizeWindowMode.cy;
	AdjustWindowRect( &g_rectWindow, WS_OVERLAPPEDWINDOW, TRUE);
	g_rectWindow.right = g_rectWindow.right - g_rectWindow.left;
	g_rectWindow.bottom = g_rectWindow.bottom - g_rectWindow.top;
	g_rectWindow.top = 0;
	g_rectWindow.left = 0;

	RECT	rect;
	if( g_bWindow )
	{
		//	iEBhE[hpj
		rect.top	= CW_USEDEFAULT;
		rect.left	= CW_USEDEFAULT;
		rect.right	= g_rectWindow.right;
		rect.bottom	= g_rectWindow.bottom;
	}
	else
	{
		//	itNXN[E[hpj
		rect.top	= 0;
		rect.left	= 0;
		rect.right	= g_sizeFullMode.cx;
		rect.bottom	= g_sizeFullMode.cy;

		g_hMenu = LoadMenu( g_hInstance, MAKEINTRESOURCE(IDR_MENU1) );
	}
	g_hWindow = CreateWindow(g_szWndClass, g_szAppTitle,
			g_bWindow ? WS_OVERLAPPEDWINDOW : WS_POPUP,
			rect.left, rect.top, rect.right, rect.bottom,
			NULL, NULL, hInst, NULL);
	if (g_hWindow == NULL)
		return DXTRACE_ERR("InitApp", GetLastError());

	// EChE\
	ShowWindow(g_hWindow, SW_SHOWNORMAL);
	UpdateWindow(g_hWindow);

	return S_OK;
}


/*-------------------------------------------
	K؂Direct3DDevicetH[}bg̑I
--------------------------------------------*/
HRESULT CheckDeviceCaps(D3DCAPS9 *Caps);							// foCX\͂̃`FbN
HRESULT SelectAdapterFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode);			// fBXvCƃobNEobt@̃tH[}bg̒
HRESULT SelectDepthStencilFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode);	// [x/XeVEobt@̃tH[}bg𒲂ׂ
HRESULT SelectRenderTexterFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode);	// _OEeNX`̃tH[}bg𒲂ׂ
HRESULT SelectMultiSampleType(UINT Adapter, D3DDEVTYPE Device);		// tV[EA`GCAVO𒲂ׂ
HRESULT SelectDisplayMode(UINT Adapter);							// fBXvCE[h𒲂ׂ

HRESULT SelectD3DDevice(UINT &Adapter, D3DDEVTYPE &Device)
{
	// A_v^̑I
	Adapter = D3DADAPTER_DEFAULT;	// vC}EfBXvCEA_v^

	// foCX\͂̎擾
	D3DCAPS9 Caps; // \͂󂯎D3DCAPS9\

	HRESULT hr;
	Device = D3DDEVTYPE_HAL;	// HALfoCX`FbN
	hr = g_pD3D->GetDeviceCaps(Adapter, Device, &Caps);
	if (FAILED(hr) || FAILED(CheckDeviceCaps(&Caps)))
	{
		DXTRACE_ERR("SelectD3DDevice CheckDeviceCaps HAL", E_FAIL);

		Device = D3DDEVTYPE_REF;	// REFfoCX`FbN
		hr = g_pD3D->GetDeviceCaps(Adapter, Device, &Caps);
		if (FAILED(hr) || FAILED(CheckDeviceCaps(&Caps)))
			return DXTRACE_ERR("SelectD3DDevice CheckDeviceCaps REF", E_FAIL);
	}

	// ݂̃fBXvC̃tH[}bgȂǂ擾Ă
	D3DDISPLAYMODE dmode;
	hr = g_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &dmode);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice GetAdapterDisplayMode", hr);

	// fBXvCƃobNEobt@̃tH[}bg̒
	hr = SelectAdapterFormat(Adapter, Device, dmode);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice SelectAdapterFormat", hr);

	// [x/XeVEobt@̃tH[}bg̒
	if (g_fmtDepthStencil != D3DFMT_UNKNOWN)
	{
		hr = SelectDepthStencilFormat(Adapter, Device, dmode);
		if (FAILED(hr))
			return DXTRACE_ERR("SelectD3DDevice SelectDepthStencilFormat", hr);
	}

	// _OEeNX`̃tH[}bg𒲂ׂ
	hr = SelectRenderTexterFormat(Adapter, Device, dmode);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice SelectRenderTexterFormat", hr);

	// ̑̃tH[}bg𒲂ׂ(Ȃ)

	// tV[EA`GCAVO𒲂ׂ
	hr = SelectMultiSampleType(Adapter, Device);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice SelectMultiSampleType", hr);

	// fBXvCE[h𒲂ׂ
	hr = SelectDisplayMode(Adapter);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectD3DDevice SelectDisplayMode", hr);

	return S_OK;
}

// foCX\͂̃`FbN
HRESULT CheckDeviceCaps(D3DCAPS9 *Caps)
{
	if (Caps->MaxStreams < 3)				// _Xg[
		return DXTRACE_ERR("CheckDeviceCaps MaxStreams < 3", E_FAIL);

	if (Caps->MaxPrimitiveCount < 0xFFFF)	// v~eBu
		return DXTRACE_ERR("CheckDeviceCaps MaxPrimitiveCount < 0xFFFF", E_FAIL);

	if (Caps->MaxVertexIndex < 0xFFFF)		// CfbNX
		return DXTRACE_ERR("CheckDeviceCaps MaxVertexIndex < 0xFFFF", E_FAIL);

//	if (Caps->VertexShaderVersion < D3DVS_VERSION(2, 0))	// _VF[_Eo[W
//		return DXTRACE_ERR("CheckDeviceCaps VertexShaderVersion < D3DVS_VERSION(2, 0)", E_FAIL);

//	if (Caps->PixelShaderVersion < D3DPS_VERSION(2, 0))	// sNZEVF[_Eo[W
//		return DXTRACE_ERR("CheckDeviceCaps PixelShaderVersion < D3DPS_VERSION(2, 0)", E_FAIL);

	return S_OK;
}

// fBXvCƃobNEobt@̃tH[}bg̒
HRESULT SelectAdapterFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode)
{
	int	i;
	HRESULT hr = S_OK;

	// EChEE[h
	ZeroMemory(&g_D3DPPWindow, sizeof(g_D3DPPWindow));
	g_D3DPPWindow.BackBufferCount			= D3DFMT_UNKNOWN;
	g_D3DPPWindow.SwapEffect				= D3DSWAPEFFECT_DISCARD;
	g_D3DPPWindow.hDeviceWindow				= g_hWindow;
	g_D3DPPWindow.Windowed					= TRUE;
	g_D3DPPWindow.PresentationInterval		= g_Interval;
	g_D3DPPWindow.EnableAutoDepthStencil	= TRUE;
	g_D3DPPWindow.AutoDepthStencilFormat	= D3DFMT_D16;

	for (int i=0; i<sizeof(g_fmtDisplay)/sizeof(g_fmtDisplay[0]); i++)
	{
		hr = g_pD3D->CheckDeviceType(Adapter, Device, dmode.Format, g_fmtDisplay[i], TRUE);
		if (SUCCEEDED(hr))
		{
			g_D3DPPWindow.BackBufferFormat = g_fmtDisplay[i];
			break;
		}
	}
	if (FAILED(hr))
		return DXTRACE_ERR("SelectAdapterFormat CheckDeviceType Window", hr);

	// tXN[E[h
	ZeroMemory(&g_D3DPPFull, sizeof(g_D3DPPFull));
	g_D3DPPFull.BackBufferCount				= 1;
	g_D3DPPFull.SwapEffect					= D3DSWAPEFFECT_DISCARD;
	g_D3DPPFull.hDeviceWindow				= g_hWindow;
	g_D3DPPFull.Windowed					= FALSE;
	g_D3DPPFull.PresentationInterval		= g_Interval;
	
	for (/*int */i=0; i<sizeof(g_fmtDisplay)/sizeof(g_fmtDisplay[0]); i++)
	{
		hr = g_pD3D->CheckDeviceType(Adapter, Device, g_fmtDisplay[i], g_fmtDisplay[i], FALSE);
		if (SUCCEEDED(hr))
		{
			g_D3DPPFull.BackBufferFormat = g_fmtDisplay[i];
			break;
		}
	}
	if (FAILED(hr))
		return DXTRACE_ERR("SelectAdapterFormat CheckDeviceType Full", hr);

	return S_OK;
}

// [x/XeVEobt@̃tH[}bg𒲂ׂ
HRESULT SelectDepthStencilFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode)
{
	HRESULT hr;

	// EChEE[h
	hr = g_pD3D->CheckDeviceFormat(Adapter, Device,
				dmode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, g_fmtDepthStencil);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectDepthStencilFormat CheckDeviceFormat DS Window", hr);

	hr = g_pD3D->CheckDepthStencilMatch(Adapter, Device,
				dmode.Format, g_D3DPPWindow.BackBufferFormat, g_fmtDepthStencil);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectDepthStencilFormat CheckDepthStencilMatch DS Window", hr);

	g_D3DPPWindow.EnableAutoDepthStencil = TRUE;
	g_D3DPPWindow.AutoDepthStencilFormat = g_fmtDepthStencil;

	// tXN[E[h
	hr = g_pD3D->CheckDeviceFormat(Adapter, Device,
				g_D3DPPFull.BackBufferFormat, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, g_fmtDepthStencil);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectDepthStencilFormat CheckDeviceFormat DS Full", hr);

	hr = g_pD3D->CheckDepthStencilMatch(Adapter, Device,
				g_D3DPPFull.BackBufferFormat, g_D3DPPFull.BackBufferFormat, g_fmtDepthStencil);
	if (FAILED(hr))
		return DXTRACE_ERR("SelectDepthStencilFormat CheckDepthStencilMatch DS Full", hr);

	g_D3DPPFull.EnableAutoDepthStencil = TRUE;
	g_D3DPPFull.AutoDepthStencilFormat = g_fmtDepthStencil;

	return S_OK;
}

// _OEeNX`̃tH[}bg𒲂ׂ
HRESULT SelectRenderTexterFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE dmode)
{
	HRESULT hr = S_OK;
	int	i;

	// EChEE[h
	g_fmtRendTexterWindow = D3DFMT_UNKNOWN;
	for (int i=0; i<sizeof(g_fmtRendTexter)/sizeof(g_fmtRendTexter[0]); i++)
	{
		hr = g_pD3D->CheckDeviceFormat(Adapter, Device,
				dmode.Format, D3DUSAGE_RENDERTARGET, D3DRTYPE_TEXTURE, g_fmtRendTexter[i]);
		if (SUCCEEDED(hr))
		{
			hr = g_pD3D->CheckDepthStencilMatch(Adapter, Device,
						dmode.Format, g_fmtRendTexter[i], g_fmtDepthStencil);
			if (SUCCEEDED(hr))
			{
				g_fmtRendTexterWindow = g_fmtRendTexter[i];
				break;
			}
		}
	}
	if (FAILED(hr))
		return DXTRACE_ERR("SelectRenderTexterFormat Window", hr);

	// tXN[E[h
	g_fmtRendTexterFull = D3DFMT_UNKNOWN;
	for (i=0; i<sizeof(g_fmtRendTexter)/sizeof(g_fmtRendTexter[0]); i++)
	{
		hr = g_pD3D->CheckDeviceFormat(Adapter, Device,
				g_D3DPPFull.BackBufferFormat,
				D3DUSAGE_RENDERTARGET, D3DRTYPE_TEXTURE, g_fmtRendTexter[i]);
		if (SUCCEEDED(hr))
		{
			hr = g_pD3D->CheckDepthStencilMatch(Adapter, Device,
					g_D3DPPFull.BackBufferFormat, g_fmtRendTexter[i], g_fmtDepthStencil);
			if (SUCCEEDED(hr))
			{
				g_fmtRendTexterFull = g_fmtRendTexter[i];
				break;
			}
		}
	}
	if (FAILED(hr))
		return DXTRACE_ERR("SelectRenderTexterFormat Full", hr);

	return S_OK;
}

// tV[EA`GCAVO𒲂ׂ
HRESULT SelectMultiSampleType(UINT Adapter, D3DDEVTYPE Device)
{
	int	i;
	int mstCount = sizeof(g_MultiSampleType) / sizeof(g_MultiSampleType[0]);

	// EChEE[h
	for (int i=0; i<mstCount; i++)
	{
		if (FAILED(g_pD3D->CheckDeviceMultiSampleType(Adapter, Device,
				g_D3DPPWindow.BackBufferFormat, TRUE, g_MultiSampleType[i], NULL)))
			continue;
		if (g_D3DPPWindow.EnableAutoDepthStencil == TRUE)
			if (FAILED(g_pD3D->CheckDeviceMultiSampleType(Adapter, Device,
					g_D3DPPWindow.AutoDepthStencilFormat, TRUE, g_MultiSampleType[i], NULL)))
				continue;
		g_D3DPPWindow.MultiSampleType	= g_MultiSampleType[i];
		g_D3DPPWindow.MultiSampleQuality = 0;
		break;
	}

	// tXN[E[h
	for (/*int */i=0; i<mstCount; i++)
	{
		if (FAILED(g_pD3D->CheckDeviceMultiSampleType(Adapter, Device,
				g_D3DPPFull.BackBufferFormat, FALSE, g_MultiSampleType[i], NULL)))
			continue;
		if (g_D3DPPWindow.EnableAutoDepthStencil == TRUE)
			if (FAILED(g_pD3D->CheckDeviceMultiSampleType(Adapter, Device,
					g_D3DPPFull.AutoDepthStencilFormat, FALSE, g_MultiSampleType[i], NULL)))
				continue;
		g_D3DPPFull.MultiSampleType	= g_MultiSampleType[i];
		g_D3DPPFull.MultiSampleQuality = 0;
		break;
	}

	return S_OK;
}

// fBXvCE[h𒲂ׂ
HRESULT SelectDisplayMode(UINT Adapter)
{
	// EChEE[h(ׂKvȂ)

	// tXN[E[h
	D3DDISPLAYMODE dmode = { 0, 0, 0, D3DFMT_UNKNOWN };
	int level = 1000000;
	int num = g_pD3D->GetAdapterModeCount(Adapter, g_D3DPPFull.BackBufferFormat);
	for (int i=0; i<num; i++)
	{
		// fBXvCE[h̗
		D3DDISPLAYMODE dm;
		g_pD3D->EnumAdapterModes(Adapter, g_D3DPPFull.BackBufferFormat, i, &dm);
		// ]̃[hƂ̌덷
		int l = abs(g_sizeFullMode.cx  - (LONG)dm.Width) + abs(g_sizeFullMode.cy  - (LONG)dm.Height);
		if (l < level)
		{
			// K؂ȃ[hI
			dmode = dm;
			level = l;
		}
	}
	if (dmode.Format == D3DFMT_UNKNOWN)
		return DXTRACE_ERR("SelectDisplayMode EnumAdapterModes", E_FAIL);

	g_D3DPPFull.BackBufferWidth  = dmode.Width;
	g_D3DPPFull.BackBufferHeight = dmode.Height;

	return S_OK;
}

/*-------------------------------------------
	DirectX Graphics
--------------------------------------------*/
HRESULT InitDXGraphics(void)
{
	// Direct3DIuWFNg̍쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (g_pD3D == NULL)
		return DXTRACE_ERR("InitDXGraphics Direct3DCreate9", E_FAIL);

	// foCXݒ̑I
	UINT Adapter;
	D3DDEVTYPE Device;
	HRESULT hr = SelectD3DDevice(Adapter, Device);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics SelectD3DDevice", hr);

	// D3DDeviceIuWFNg̍쐬
	if (g_bWindow)
		g_D3DPP = g_D3DPPWindow;
	else
		g_D3DPP = g_D3DPPFull;

	hr = g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, g_hWindow,
						D3DCREATE_HARDWARE_VERTEXPROCESSING, &g_D3DPP, &g_pD3DDevice);
	if (FAILED(hr))
	{
		hr = g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, g_hWindow,
						D3DCREATE_SOFTWARE_VERTEXPROCESSING, &g_D3DPP, &g_pD3DDevice);
		if (FAILED(hr))
			return DXTRACE_ERR("InitDXGraphics CreateDevice", hr);
	}

	//	X|P@bV̓ǂݍ

	LPD3DXBUFFER	pD3DXMtrlBuffer;
	hr = D3DXLoadMeshFromX( _T("tiger.x"),
		D3DXMESH_SYSTEMMEM,
		g_pD3DDevice,
		NULL,
		&pD3DXMtrlBuffer,
		NULL,
		&g_dwNumMaterials,
		&g_pD3DXMesh );
	if( FAILED(hr) )
		return false;

	//	X|Q	}eAƃeNX`̏
	g_pMeshTexture = new LPDIRECT3DTEXTURE9[ g_dwNumMaterials ];
	g_pMeshMaterials = new D3DMATERIAL9[ g_dwNumMaterials ];

	//	}eAobt@̃|C^擾
	D3DXMATERIAL*	d3dxMaterials = (D3DXMATERIAL*)pD3DXMtrlBuffer->GetBufferPointer();

	//	e}eAۑ
	for( DWORD i=0; i<g_dwNumMaterials; i++ )
	{
		g_pMeshMaterials[i] = d3dxMaterials[i].MatD3D;
		g_pMeshMaterials[i].Ambient = g_pMeshMaterials[i].Diffuse;
        g_pMeshTexture[i] = NULL;
        if( d3dxMaterials[i].pTextureFilename != NULL &&
            lstrlenA( d3dxMaterials[i].pTextureFilename ) > 0 )
        {
            // Create the texture
            if( FAILED( D3DXCreateTextureFromFileA( g_pD3DDevice,
                                                    d3dxMaterials[i].pTextureFilename,
                                                    &g_pMeshTexture[i] ) ) )
            {
                // If texture is not in current folder, try parent folder
                const CHAR* strPrefix = "..\\";
                CHAR strTexture[MAX_PATH];
                strcpy_s( strTexture, MAX_PATH, strPrefix );
                strcat_s( strTexture, MAX_PATH, d3dxMaterials[i].pTextureFilename );
                // If texture is not in current folder, try parent folder
                if( FAILED( D3DXCreateTextureFromFileA( g_pD3DDevice,
                                                        strTexture,
                                                        &g_pMeshTexture[i] ) ) )
                {
                    MessageBox( NULL, _T("Could not find texture map"), _T("Meshes.exe"), MB_OK );
                }
            }
        }
	}

	//	t@Cǂݍ񂾃}eÃobt@
	RELEASE( pD3DXMtrlBuffer );

	return S_OK;
}

/*-------------------------------------------
	D3DɊǗȂIuWFNg̏
--------------------------------------------*/
HRESULT InitD3DObject(void)
{
	// _OEXe[g̐ݒ
	// Zobt@̐ݒ
	g_pD3DDevice->SetRenderState(D3DRS_ZENABLE,
		g_D3DPP.EnableAutoDepthStencil ? D3DZB_TRUE : D3DZB_FALSE);

	// }`TvO̐ݒ
	g_pD3DDevice->SetRenderState(D3DRS_AMBIENT,
		g_D3DPP.MultiSampleType != D3DMULTISAMPLE_NONE ? TRUE : FALSE);

	return S_OK;
}

//-----------------------------------------------------
//	Name:	SetupMatrices()
//	Desc:	
//-----------------------------------------------------
void	SetupMatrices()
{
	D3DXMATRIXA16	matWorld;
	D3DXMatrixRotationY( &matWorld, timeGetTime() / 1000.1f );
	g_pD3DDevice->SetTransform( D3DTS_WORLD, &matWorld );

	D3DXVECTOR3		vEyePt( 0.0f, 3.0f, -5.0f );
	D3DXVECTOR3		vLookatPt( 0.0f, 0.0f, 0.0f );
	D3DXVECTOR3		vUpVec( 0.0f, 1.0f, 0.0f );
	D3DXMATRIXA16	matView;
	D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
	g_pD3DDevice->SetTransform( D3DTS_VIEW, &matView );

	D3DXMATRIXA16	matProj;
	D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI / 4, 1.0f, 1.0f, 100.0f );
	g_pD3DDevice->SetTransform( D3DTS_PROJECTION, &matProj );

	D3DXMATRIX	mat;
	mat = matWorld * matView * matProj;
	D3DXMatrixTranspose( &mat, &mat );
	g_pD3DDevice->SetVertexShaderConstantF( 0, (float*)&mat, 4 );

}

/*--------------------------------------------
	ʂ̕`揈
--------------------------------------------*/
HRESULT Render(void)
{
	// V[̃NA
	HRESULT	hr;
	hr = g_pD3DDevice->Clear(0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0, 0, 255), 1.0f, 0);

	// V[̕`Jn
	if (SUCCEEDED(g_pD3DDevice->BeginScene()))
	{
		SetupMatrices();

		//	X|T	bV̕`
		for( DWORD i=0; i<g_dwNumMaterials; i++ )
		{
			g_pD3DDevice->SetMaterial( &g_pMeshMaterials[i] );
			g_pD3DDevice->SetTexture( 0, g_pMeshTexture[i] );
			g_pD3DXMesh->DrawSubset(i);
		}

		// V[̕`I
		g_pD3DDevice->EndScene();
	}

	// V[̕\
	g_pD3DDevice->Present(NULL, NULL, NULL, NULL);

	return hr;
}

/*-------------------------------------------
	D3DɊǗȂIuWFNg̏I
--------------------------------------------*/
HRESULT CleanupD3DObject(void)
{
	// XvCg̏
	if (g_pD3DXSprite)
		g_pD3DXSprite->OnLostDevice();

	// tHg̏
	if (g_pD3DXFont)
		g_pD3DXFont->OnLostDevice();

	return S_OK;
}

/*-------------------------------------------
	EChEETCY̕ύX
--------------------------------------------*/
HRESULT ChangeWindowSize(void)
{
	// EChẼNCAg̈ɍ킹
	CleanupD3DObject();

	HRESULT hr = g_pD3DDevice->Reset(&g_D3DPP);
	if (FAILED(hr))
	{
		if (hr == D3DERR_DEVICELOST)
			g_bDeviceLost = true;
		else
			DestroyWindow(g_hWindow);
		return DXTRACE_ERR("ChangeWindowSize Reset", hr);
	}
	hr = InitD3DObject();
	if (FAILED(hr))
	{
		DestroyWindow(g_hWindow);
		return DXTRACE_ERR("ChangeWindowSize InitD3DObject", hr);
	}

	// r[|[g̐ݒ
	D3DVIEWPORT9 vp;
	vp.X		= 0;
	vp.Y		= 0;
	vp.Width	= g_D3DPP.BackBufferWidth;
	vp.Height	= g_D3DPP.BackBufferHeight;
	vp.MinZ		= 0.0f;
	vp.MaxZ		= 1.0f;
	hr = g_pD3DDevice->SetViewport(&vp);
	if (FAILED(hr))
	{
		DXTRACE_ERR("ChangeWindowSize SetViewport", hr);
		DestroyWindow(g_hWindow);
	}
	return hr;
}


/*-------------------------------------------
	ʃ[h̕ύX
--------------------------------------------*/
void ChangeDisplayMode(void)
{
	g_bWindow = !g_bWindow;

	CleanupD3DObject();

	if (g_bWindow)
	{
		g_D3DPP = g_D3DPPWindow;
	}
	else
	{
		g_D3DPP = g_D3DPPFull;
		GetWindowRect(g_hWindow, &g_rectWindow);
	}

	HRESULT hr = g_pD3DDevice->Reset(&g_D3DPP);
	if (FAILED(hr))
	{
		if (hr == D3DERR_DEVICELOST)
			g_bDeviceLost = true;
		else
			DestroyWindow(g_hWindow);
		DXTRACE_ERR("ChangeDisplayMode Reset", hr);
		return;
	}

	hr = InitD3DObject();
	if (FAILED(hr))
	{
		DXTRACE_ERR("ChangeDisplayMode InitD3DObject", hr);
		DestroyWindow(g_hWindow);
		return;
	}

	if (g_bWindow)
	{
		SetWindowLong(g_hWindow, GWL_STYLE, WS_OVERLAPPEDWINDOW | WS_VISIBLE);
		if(g_hMenu != NULL)
		{
			SetMenu(g_hWindow, g_hMenu);
			g_hMenu = NULL;
		}
		SetWindowPos(g_hWindow, HWND_NOTOPMOST,
				g_rectWindow.left, g_rectWindow.top,
				g_rectWindow.right - g_rectWindow.left,
				g_rectWindow.bottom - g_rectWindow.top,
				SWP_SHOWWINDOW);
	}
	else
	{
		SetWindowLong(g_hWindow, GWL_STYLE, WS_POPUP | WS_VISIBLE);
		if(g_hMenu == NULL)
		{
			g_hMenu = GetMenu(g_hWindow);
			SetMenu(g_hWindow, NULL);
		}
	}
}

/*-------------------------------------------
	DirectX Graphics̏I(ɎsƂĂ΂)
--------------------------------------------*/
bool CleanupDXGraphics(void)
{
	// 擾IuWFNg̊J
	RELEASE(g_pD3DXFont);
	RELEASE(g_pD3DXSprite);
	RELEASE(g_pD3DTexture);
	RELEASE(g_pD3DDevice);
	RELEASE(g_pD3D);

	return true;
}

/*-------------------------------------------
	AvP[V̏IiŌɌĂ΂j
--------------------------------------------*/
bool CleanupApp(void)
{
	for( DWORD i=0; i<g_dwNumMaterials; i++ )
		RELEASE( g_pMeshTexture[i] );

	delete[]	g_pMeshMaterials;
	delete[]	g_pMeshTexture;
	RELEASE( g_pD3DXMesh );

	//	j[Enh̍폜
	if( g_hMenu )
		DestroyMenu( g_hMenu );

	// EChEENX̓o^
	UnregisterClass(g_szWndClass, g_hInstance);
	return true;
}

/*-------------------------------------------
	EBhE
--------------------------------------------*/
HRESULT SaveFrontBuffer(void);	// ʃLv`

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, UINT wParam, LONG lParam)
{
	HRESULT hr = S_OK;

	switch(msg)
	{
	case WM_ACTIVATE:
		g_bActive = (LOWORD(wParam) != 0);
		break;

	case WM_DESTROY:
		// D3DɊǗȂIuWFNg̏I
		CleanupD3DObject();
		// DirectX Graphics̏I
		CleanupDXGraphics();
		// EChE
		PostQuitMessage(0);
		g_hWindow = NULL;
		return 0;

	// EChEETCY̕ύX
	case WM_SIZE:
		if (g_D3DPP.Windowed != TRUE)
			break;
		if (!g_pD3DDevice || wParam == SIZE_MINIMIZED)
			break;
		g_D3DPP.BackBufferWidth  = LOWORD(lParam);
		g_D3DPP.BackBufferHeight = HIWORD(lParam);
		if(g_bDeviceLost)
			break;
		if (wParam == SIZE_MAXIMIZED || wParam == SIZE_RESTORED)
			ChangeWindowSize();
		break;

	case WM_SETCURSOR:
		if (g_pD3DDevice)
		{
			if (LOWORD(lParam) == HTCLIENT)	// NCAg̈̂
			{
				SetCursor(NULL);				// EChE̕WJ[\
				g_pD3DDevice->ShowCursor(TRUE);	// DirectX Graphics̃J[\@\g
				return TRUE;					// ݒIƂʒm
			}
		}
		break;

	case WM_MOUSEMOVE:
		if (g_pD3DDevice)
		{
			POINT ptCursor;
			GetCursorPos(&ptCursor);
			g_pD3DDevice->SetCursorPosition(ptCursor.x, ptCursor.y, 0L);
		}
		break;

	case WM_KEYDOWN:
		// L[͂̏
		switch(wParam)
		{
		case VK_ESCAPE:	// [ESCAPE]L[ŃEChE
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		case 'W':	// ʃ[h̐؂ւ
			ChangeDisplayMode();
			break;
		case 'S':	// ʃLv`
			SaveFrontBuffer();
			break;
		}
		break;

	case WM_COMMAND:
		// Iꂽj[s
		switch (LOWORD(wParam))
		{
		case IDM_EXIT:
			DestroyWindow(hWnd);
			return 0;
		}
		break;
	}

	// ftHg
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

// ʃLv`
HRESULT SaveFrontBuffer(void)
{
	HRESULT hr;

	// ݂̃fBXvC̃tH[}bgȂǂ擾
	D3DDISPLAYMODE dmode;
	hr = g_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &dmode);
	if (FAILED(hr))
		return DXTRACE_ERR("SaveFrontBuffer GetAdapterDisplayMode", hr);

	// Lv`pT[tFX쐬
	LPDIRECT3DSURFACE9 pSurface; // T[tFX
	hr = g_pD3DDevice->CreateOffscreenPlainSurface(
			dmode.Width,
			dmode.Height,
			D3DFMT_A8R8G8B8,		// ̏ꍇAWI32rbgEtH[}bg
			D3DPOOL_SCRATCH, &pSurface, NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("SaveFrontBuffert CreateOffscreenPlainSurface", hr);

	// Lv`
	hr = g_pD3DDevice->GetFrontBufferData(0, pSurface);
	if (FAILED(hr))
	{
		RELEASE(pSurface);
		return DXTRACE_ERR("SaveFrontBuffert GetFrontBufferData", hr);
	}

	// T[tFX̕ۑ
	RECT rect;
	if (g_D3DPP.Windowed)
	{
		POINT p = { 0, 0 };
		ClientToScreen(g_hWindow, &p);
		rect.left = p.x; rect.top = p.y;
		p.x = g_D3DPP.BackBufferWidth;
		p.y = g_D3DPP.BackBufferHeight;
		ClientToScreen(g_hWindow, &p);
		rect.right = p.x; rect.bottom = p.y;
	}
	hr = D3DXSaveSurfaceToFile(
			g_szFontBufferFile,	// ۑt@C
			D3DXIFF_BMP,		// BMP`
			pSurface,			// ۑT[tFX
			NULL,				// pbg
			g_D3DPP.Windowed ? &rect : NULL); // ۑ̈
	RELEASE(pSurface);
	if (FAILED(hr))
		return DXTRACE_ERR("SaveFrontBuffert D3DXSaveSurfaceToFile", hr);

	return S_OK;

}


/*--------------------------------------------
	ACh̏
--------------------------------------------*/
bool AppIdle(void)
{
	if (!g_pD3D || !g_pD3DDevice)
		return false;

	if (!g_bActive)
		return true;

	// foCX̕
	HRESULT hr;
	if (g_bDeviceLost)
	{
		Sleep(100);	// 0.1b҂

		// foCXԂ̃`FbN
		hr  = g_pD3DDevice->TestCooperativeLevel();
		if (FAILED(hr))
		{
			if (hr == D3DERR_DEVICELOST)
				return true;  // foCX͂܂Ă

			if (hr != D3DERR_DEVICENOTRESET)
				return false; // \ʃG[

			CleanupD3DObject(); // Direct3DŊǗĂȂ\[XJ
			hr = g_pD3DDevice->Reset(&g_D3DPP); // ݂
			if (FAILED(hr))
			{
				if (hr == D3DERR_DEVICELOST)
					return true; // foCX͂܂Ă

				DXTRACE_ERR("AppIdle Reset", hr);
				return false; // foCX̕Ɏs
			}
			hr = InitD3DObject();  // JDirect3DŊǗĂȂ\[XĎ擾
			if (FAILED(hr))
			{
				DXTRACE_ERR("AppIdle InitD3DObject", hr);
				return false;
			}
		}
		// foCX
		g_bDeviceLost = false;
	}

	// ʂ̍XV
	hr = Render();
	if (hr == D3DERR_DEVICELOST)
		g_bDeviceLost = true;	// foCX̏
	else if (FAILED(hr))
		return false;

	return true;
}

/*--------------------------------------------
	C
---------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	// AvP[VɊւ鏉
	HRESULT hr = InitApp(hInst);
	if (FAILED(hr))
	{
		DXTRACE_ERR("WinMain InitApp", hr);
		return 0;
	}

	// DirectX Graphics̏
	hr = InitDXGraphics();
	if (FAILED(hr))
		DXTRACE_ERR("WinMain InitDXGraphics", hr);
	else
	{
		// D3DɊǗȂIuWFNg̏
		hr = InitD3DObject();
		if (FAILED(hr))
		{
			DXTRACE_ERR("WinMain InitD3DObject", hr);
			DestroyWindow(g_hWindow);
		}
	}
	
	// bZ[WE[v
	MSG msg;
	do
	{
		if (PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			// ACh
			if (!AppIdle())
				// G[ꍇCAvP[VI
				DestroyWindow(g_hWindow);
		}
	} while (msg.message != WM_QUIT);

	// AvP[V̏I
	CleanupApp();

	return msg.wParam;
}

